// .. platform dependent parts

//..needed to get stat64 with mingw
#undef __MSVCRT_VERSION__
#define __MSVCRT_VERSION__  0x601

#ifndef _MSC_VER
  #include <unistd.h>
  #include <utime.h>
#else
  #include <windows.h>
  #include <sys/utime.h>
#endif
#include "some_ut4.h"
#include <cmath>

class filei{
  public:
  char *f;  // file name
  int i;    // number of directory in the path
  int j;    // index of the pathext value
};

class diri{
  public:
  char *d;  // directory name
  int i;    // number of directory in the path
  bool u;   // false if a duplicate in the path and not the first
};

int strcmp_nocase(const char x[], const char y[])
{
  // .. case insensitive comparison
  int i, l, lx, ly;
  char cx, cy;
  lx=strlen(x);
  ly=strlen(y);
  l=lx;
  if(ly<l)l=ly;
  for(i=0; i<l; i++)
  {
    cx=x[i];
    cy=y[i];
    if('A'<=cx && cx<='Z')cx=char('a'+(cx-'A'));
    if('A'<=cy && cy<='Z')cy=char('a'+(cy-'A'));
    if(cx<cy)return -1;
    if(cx>cy)return +1;
  }
  if(lx>ly)return 1;
  if(ly>lx)return -1;
  return 0;
}

void trim(char a[])
{
  int i, l;
  l=strlen(a);
  for(i=l-1; i>=0; i--)
    if(isspace(a[i]))a[i]=0;
    else             break;
}

void trim_t(t_file& t)
{
  for(int i=0; i<t.nl; i++)trim(t.cl[i]);
}

int order_exe(const void *aa, const void *bb)
{
  const filei& a=*(const filei*)aa;
  const filei& b=*(const filei*)bb;
  int k=strcmp_nocase(a.f, b.f);
  if(k!=0)return k;
  if(a.j<b.j)return -1;
  if(a.j>b.j)return +1;
  if(a.i<b.i)return -1;
  if(a.i>b.i)return +1;
  return 0;
}

int order_dir_name(const void *aa, const void *bb)
{
  const diri& a=*(const diri*)aa;
  const diri& b=*(const diri*)bb;
  int k=strcmp_nocase(a.d, b.d);
  if(k!=0)return k;
  if(a.i<b.i)return -1;
  if(a.i>b.i)return +1;
  return 0;
}

int order_dir_i(const void *aa, const void *bb)
{
  const diri& a=*(const diri*)aa;
  const diri& b=*(const diri*)bb;
  if(a.i<b.i)return -1;
  if(a.i>b.i)return +1;
  return strcmp_nocase(a.d, b.d);
}

int main(int argc, char *argv[])
{
  #include "some_ut_in_main4.h"

  t_file t;
  command_output("set", 'a', t);
  trim_t(t);

  int i, j, k, l, le, lp, ne, np, n, npu;
  char *d, *de, c2[3];
  string se, sp, sf, sd, s, s2;
  char q='"';

  // .. get the patheext and path
  for(i=0; i<t.nl; i++)
  {
    d=t.cl[i];
    if(mkwfind_nocase(d, "pathext=")==0)se=&d[8];
    if(mkwfind_nocase(d, "path=")==0)sp=&d[5];
  }

  d=&se[0];
  le=strlen(d);
  char **e=new char*[le+1];
  for(i=0; i<le; i++)
    if(d[i]==';')d[i]=0;
  ne=0;
  e[ne]=d;
  ne++;
  for(i=1; i<le; i++)
    if(d[i]==0){e[ne]=&d[i+1]; ne++;}

  d=&sp[0];
  lp=strlen(d);
  char **p=new char*[lp+1];
  for(i=0; i<lp; i++)
    if(d[i]==';')d[i]=0;
  np=0;
  p[np]=d;
  np++;
  for(i=1; i<lp; i++)
    if(d[i]==0)
    {
      if(strlen(&d[i+1])==0)continue;
      p[np]=&d[i+1]; 
      np++;
    }

  cout << "number of components in pathext=" << ne << endl;
  cout << "number of folders in the path=" << np << endl;

  // .. get the unique folders
  diri *pu=new diri[np+1];
  for(i=0; i<np; i++)
  {
    pu[i].d=p[i];
    pu[i].i=i;
    pu[i].u=true;
  }

  // .. sort by name
  qsort(pu, np, sizeof(pu[0]), order_dir_name);

  // .. change any .u entries to false if not to use
  for(i=1; i<np; i++)
  {
    if(strlen(pu[i].d) != strlen(pu[i-1].d))continue;
    if(mkwfind_nocase(pu[i].d, pu[i-1].d)<0)continue;
    pu[i].u=false;
  }

  npu=0;
  for(i=0; i<np; i++)
    if(pu[i].u)npu++;
  cout << "number of unique folders in the path=" << npu << endl;

  // re-sort by position in the list
  qsort(pu, np, sizeof(pu[0]), order_dir_i);

  cout << "..listing all the folders" << endl;
  t_file *tp=new t_file[np+1];
  int nf=0;
  for(i=0; i<np; i++)
  {
    if(pu[i].u==false)continue;
    if(exists_dir(pu[i].d)==0)continue;

    mstrncpy(c2, pu[i].d, 2);
    c2[2]=0;
    s=c2;
    s=s+" && cd "+q+pu[i].d+q +" && dir/b";
    t_file& t=tp[i];
    command_output(s.c_str(), 'a', t);
    trim_t(t);
    nf += t.nl;
  }
  cout << "number of files in all the folders=" << nf << endl;

  filei *a=new filei[2*nf+1];
  k=0;
  for(i=0; i<np; i++)
  {
    if(exists_dir(p[i])==0)continue;
    t_file& t=tp[i];

    mstrncpy(c2, p[i], 2);
    c2[2]=0;
    s=c2;
    s=s+" && cd "+q+p[i]+q +" && dir/b";
    
    command_output(s.c_str(), 'a', t);
    if(k+t.nl>2*nf)break;
    for(j=0; j<t.nl; j++)
    {
      d=t.cl[j];
      a[k].f=d;
      a[k].i=i;
      k++;
    }
  }

  filei *b=new filei[k+1];
  n=0;
  for(i=0; i<k; i++)
  {
    d=a[i].f;
    l=strlen(d);
    de=blank;
    for(j=l-1; j>=0; j--)
      if(d[j]=='.'){de=&d[j]; break;}
    if(strlen(de)==0)continue;

    for(j=0; j<ne; j++)
      if(mkwfind_nocase(de, e[j])==0)
      {
        b[n].f=a[i].f;
	b[n].i=a[i].i;
	b[n].j=j;
	n++;
	break;
      }
  }
  cout << "number of files with pathext endings in all the folders=" 
       << n << endl;

  // .. sort the entries
  qsort(b, n, sizeof(b[0]), order_exe);

  // .. write to a file
  char *pt=getenv("TEMP");
  sf="";
  sd="";
  if(pt!=NULL)
  {
    sf=pt;
    sf=sf+"\\";
    sd=pt;
    sd=sd+"\\";
  }
  sf=sf+"all_exe_etc_in_path.txt";
  sd=sd+"all_folders_in_path.txt";

  char c14[15];
  int bytes, isdir;

  ofstream O(sf.c_str());
  for(i=0; i<n; i++)
  {
    s2=p[b[i].i];
    s2=s2+"\\"+b[i].f;
    
    file_details(s2.c_str(), c14, bytes, isdir);
    O << left << setw(16) << b[i].f << right
      << " " << setw(9) << bytes << ",  date=" << c14 
      << ", folder=" << p[b[i].i] << endl;
  }

  O.close();

  t_file t2(sf.c_str(), 1);
  t2.close();

  O.open(sd.c_str());
  for(i=0; i<np; i++)
    O << p[i] << endl;
  O.close();

  t2.open(sd.c_str(), 1);
  t2.close();

  delete[] e;
  delete[] p;
  delete[] tp;
  delete[] a;
  delete[] b;

  // .. show with notepad++ or leave
  for(i=1; i<argc; i++)
    if(strcmp_nocase(argv[i], "-no_show")==0)return 0;
  cout << "Type all_exe.exe -no_show if you do not want notepad++ to be used"
       << endl; 

  string sv;
  sv="notepad++ ";
  sv=sv+q+sf+q;
  system(sv.c_str());

  return 0;
}
