#include "some_ut4.h"
#include <cmath>

struct char_ind{
  char *c;  // c-string
  int i;    // original index
  int si;   // sorted index
  int u;    // 1 if to be used, 0 otherwise
};

const char *terms[]={
  "set", "subst", "net use", "wmic", "adobe", "ipconfig", "whoami"
};
int nterms;
int *iterms;
char letu[27], letnu[27];

void usage(const char a[])
{
  cout << "..stopping because: " << a << endl;
  exit(0);
}

int order_char_ind(const void *aa, const void *bb)
{
  // .. sort by the string and then by the index
  const char_ind& a=*(const char_ind*)aa;
  const char_ind& b=*(const char_ind*)bb;
  int k;
  k=strcmp(a.c, b.c);
  if(k!=0)return k;
  if(a.i<b.i)return -1;
  if(a.i>b.i)return +1;
  return 0;
}

int order_char_indi(const void *aa, const void *bb)
{
  // .. sort by the string and then by the index
  const char_ind& a=*(const char_ind*)aa;
  const char_ind& b=*(const char_ind*)bb;
  if(a.i<b.i)return -1;
  if(a.i>b.i)return +1;
  return 0;
}

int get_pos(int n, const char *a[], const char b[])
{
  int i;
  for (i=0; i<n; i++)
    if (strcmp(a[i], b)==0)return i;
  return -1;
}


void set_dr_tmp(t_file& t)
{
  // .. get the temp variable and set a drive to it if not already done
  int i, iw, iws;
  char *d;
  iw=get_pos(nterms, terms, "set");
  if (iw<0)return;

  char *dtem=blank;
  for (i=iterms[2*iw]+1; i<=iterms[2*iw+1]; i++)
  {
    d=t.cl[i];
    if (mkwfind_nocase(d, "temp=")!=0)continue;
    cout << d << endl;
    dtem=d;
    break;
  }
  if (strlen(dtem)==0)return;
  int ke=mkwfind(dtem, "=");

  iws=get_pos(nterms, terms, "subst");
  if (iws<0)return;
  for (i=iterms[2*iws]+1; i<=iterms[2*iws+1]; i++)
  {
    d=t.cl[i];
    if (mkwfind_nocase(d, &dtem[ke+1])>0)
    {
      cout << "..we already have " << d << endl;
      return;
    }
  }

  // .. get the first available letter starting from Y going backwards
  char q='"';
  string s;
  for (i=24; i>=0; i--)
  {
    if (letu[i]!='-')continue;
    s="subst ";
    s=s+char('A'+i)+": "+q+&dtem[ke+1]+q;
    mkwsystem(s.c_str());
    letu[i]=char('A'+i);
    letnu[i]='-';
    break;
  }
}


void set_path(t_file& t, string& fn)
{
  // .. get the acrod32 directory and create a batch file to
  // .. reset the path

  int i, iw, iwp, j, l;
  char *d, *adobe=blank;
  iw=get_pos(nterms, terms, "adobe");
  iwp=get_pos(nterms, terms, "set");
  if (iwp<0)return;

  const char z[]="\\acrord32.exe";
  int lz=strlen(z);
  for(i=iterms[2*iw]+1; i<=iterms[2*iw+1]; i++)
  {
    d=t.cl[i];
    l=strlen(d);
    j=mkwfind_nocase(d, "\\acrord32.exe");
    if(l==j+lz)
    {
      cout << d << endl;
      d[j]=0;
      adobe=d;
    }
  } 

  // .. get the path and add adobe
  string s="";
  for(i=iterms[2*iwp]+1; i<=iterms[2*iwp+1]; i++)
  {
    d=t.cl[i];
    l=strlen(d);
    j=mkwfind_nocase(d, "path=");
    if(j!=0)continue;
    s=d;
    s=s+";"+adobe+";";
    break;
  }
  l=s.length();
  if(l==0)return;
  LINEPR(s)

  // ..remove any quotes creating b[] and count the semi-colons
  // ..and ensure that it is null terminated
  char *a=&s[0];
  char *b=new char[l+3];
  int np=0;
  j=0;
  for(i=0; i<l; i++)
  {
    if(a[i]=='"')continue;
    b[j]=a[i];
    if(b[j]==';')np++;
    j++;
  }
  if(b[j-1]!=';')np++;
  b[j]=0;
  l=j;

  // .. now create an array of c-strings for each of the directories
  char **pb=new char*[np+1];
  int k;
  int ke=mkwfind(b, "=");
  k=0;
  pb[k]=&b[ke+1];
  k++;
  for(i=ke+1; i<l; i++)
  {
    if(b[i]==';')
    {
      pb[k]=&b[i+1];
      b[i]=0;
      k++;
    }
  }
  np=k;

  // .. create an array of a type which has pointers 
  // .. to the c-strings and positions before and after sorting
  char_ind *ppb=new char_ind[np+1];

  for(i=0; i<np; i++)
  {
    ppb[i].c=pb[i];
    ppb[i].i=i;
    ppb[i].si=-1;
    ppb[i].u=0;
  }

  qsort(ppb, np, sizeof(ppb[0]), order_char_ind);

  // .. set the sorted position
  for(i=0; i<np; i++) ppb[i].si=i;

  // .. group them
  int *ig=new int[np+1];
  ig[0]=0;
  j=1;
  for(i=1; i<np; i++)
  {
    if(strcmp(ppb[i].c, ppb[i-1].c)!=0)
    {
      ig[j]=i;
      j++;
    }
  }
  ig[j]=np;

  // .. mark the first in the group as to be used
  for(i=0; i<j; i++)
  {
    k=ig[i];
    ppb[k].u=1;
  }

  qsort(ppb, np, sizeof(ppb[0]), order_char_indi);

  string sfn;
  sfn=fn;
  sfn=sfn+".bat";

  ofstream O(sfn.c_str());
  O << "set path=";
  for(i=0; i<np; i++)
  {
    if(ppb[i].u==0)continue;
    d=ppb[i].c;
    if(strlen(d)==0)continue;
    O << d << ";";
  }
  O << endl;
  O.close();

  delete[] ig;
  delete[] b;
  delete[] pb;
  delete[] ppb;
}

void at_brunel(t_file& t, int& br_ip)
{
  // .. determine if the pc is part of the brunel network
  br_ip=0;

  int i, iw;
  char *d;
  string s;

  iw=get_pos(nterms, terms, "ipconfig");
  if (iw<0)return;
  for (i=iterms[2*iw]+1; i<=iterms[2*iw+1]; i++)
  {
    d=t.cl[i];
    if (mkwfind(d, "Default Gateway")<0)continue;
    s=d;
    if(i+1<t.nl)s=s+"  "+t.cl[i+1];
    cout << s << endl;
    if (mkwfind(s.c_str(), "134.83.")>=0)br_ip=1;
    break;
  }
}

int main(int argc, char *argv[])
{
#include "some_ut_in_main4.h"

  string s;
  int i;

  if (argc<=1)usage("no file name with the data given");

  // .. get the name of the file with the data
  s=argv[1];
  for (i=2; i<argc; i++)
  {
    if (argv[i][0]=='-')break;
    s=s+argv[i];
  }
  string afn=s;
  char *fn=&s[0];
  if (exists(fn)==0)
  {
    cout << "file " << fn << " does not exist" << endl;
    usage("...cannot continue without the data");
  }

  // .. read into an array and remove any nulls
  int n;
  char *c=f2a(fn, n);
  if (n<=0)
  {
    cout << "file " << fn << " exists but is empty" << endl;
    usage("...cannot continue without the data");
  }

  char *cn=new char[n+1];
  int m=0;
  for (i=0; i<n; i++)
  {
    if (c[i]==0)continue;
    cn[m]=c[i];
    m++;
  }
  delete[] c;

  // .. create a cleaned up version and read again
  s=fn;
  s=s+"_no_nulls";
  a2f(cn, m, s.c_str());
  delete[] cn;
  t_file t(s.c_str(), 1);

  // .. locate the different parts
  nterms=sizeof(terms)/sizeof(terms[0]);
  iterms=new int[2*nterms];
  for (i=0; i<nterms; i++) {
    iterms[2*i]=-1;
    iterms[2*i+1]=-2;
  }

  int j, k, l;
  char *d;
  for (i=0; i<t.nl; i++)
  {
    d=t.cl[i];
    l=strlen(d);
    if (l<10)continue;
    if (strncmp(d, "____", 4)!=0)continue;
    if (mkwfind(d, " next")<4)continue;
    for (j=0; j<nterms; j++)
    {
      if (mkwfind(d, terms[j])<0)continue;
      iterms[2*j]=i;
      break;
    }
  }
  for (i=0; i<nterms; i++)
  {
    if (iterms[2*i]<0)continue;
    iterms[2*i+1]=t.nl-1;
    for (j=0; j<nterms; j++)
    {
      if (j==i)continue;
      k=iterms[2*j];
      if (k<iterms[2*i])continue;
      if (k<iterms[2*i+1])iterms[2*i+1]=k-1;
    }
  }

  for (i=0; i<nterms; i++)
    cout << left << setw(16) << terms[i] << " : " << right
         << setw(5) << iterms[2*i] << " to "
         << setw(5) << iterms[2*i+1] << endl;

  // .. get the drive letters that are already used from the wmic data
  int iw=get_pos(nterms, terms, "wmic");
  k=iterms[2*iw]+1;
  char *dh=t.cl[k];
  j=mkwfind(dh, "Caption");
  char c1;
  for (i=0; i<26; i++) {
    letu[i]='-';
    letnu[i]=char('A'+i);
  }
  letu[26]=0;
  letnu[26]=0;
  for (i=k; i<=iterms[2*iw+1] && j>=0; i++)
  {
    d=t.cl[i];
    c1=d[j];
    if (c1<'A' || c1>'Z')continue;
    letu[c1-'A']=c1;
    letnu[c1-'A']='-';
  }
  cout << "drive letters used=    " << letu << endl;
  cout << "drive letters not used=" << letnu << endl;

  // .. determine if at brunel
  int br_ip, vpn;
  vpn=1;
  at_brunel(t, br_ip);
  if(br_ip==0)vpn=0;
  if(letu[ 'L'-'A' ]=='L')vpn=0;

  if(br_ip)cout << "In the Brunel network" << endl;
  else     cout << "Not in the Brunel network" << endl;
  if(vpn)  cout << "VPN may be running, no L: drive" << endl;

  // .. set a drive for temp
  set_dr_tmp(t);

  // .. set the path
  set_path(t, afn);
  return 0;
}
