#include "some_ut4.h"
#include <cmath>

void usage(const char a[])
{
  cout << "..stopping because: " << a << endl;
  exit(0);
}

int mkw_mkdir(const char d[])
{
  // .. attempt to create a folder, uses system to work with linux and windows

  // .. windows versions uses system()
  char q='"';
  string s="mkdir ";
  s=s+q+d+q;
  system(s.c_str());
  return 0;
}

int main(int argc, char *argv[])
{
  #include "some_ut_in_main4.h"

  // .. check for enough args
  if(argc<3)usage("argc<3");
  if(exists(argv[2])==0)usage("argv[2] does not exist");
  if(exists_dir(argv[2]))usage("argv[2] is a directory but needs to be a file");

  int i, j, j2, k, l, n, idir;

  // .. check if overwrite is to be done
  int overw=0;
  for(i=3; i<argc; i++)
    if(strcmp(argv[i], "-o")==0)overw=1;

  char z=sys_prop.s;
  cout << "z=" << z << endl;

  // .. get the last part of argv[2];
  l=strlen(argv[2]);
  j2=0;
  for(i=l-1; i>=0; i--)
    if(argv[2][i]==z){j2=i+1; break;}

  // .. take a copy of argv[1] and set sfull
  string s=argv[1];
  char *d=&s[0];
  l=strlen(d);
  string sfull=s; 
  if(d[l-1]!=z)sfull=sfull+z;
  sfull=sfull+&argv[2][j2];

  // .. get the p= line in the file argv[2]
  t_file tm(argv[2], 1);
  string sp="";
  int ip;
  for(i=tm.nl-1; i>=0; i--)
  {
    d=tm.cl[i];
    if(strncmp(d, "p=", 2)==0)
    {
      sp=d;
      ip=i;
      break;
    }
  }

  // .. check if already exists and creates the p= line
  t_file tr;
  int already_done=0;
  if(exists(&sfull[0]))
  {
    tr.open(&sfull[0], 1);
    for(i=tr.nl-1; i>=0; i--)
    {
      d=tr.cl[i];
      if(mkwfind(d, &sp[0])>=0)
      {
        cout << sfull << " already exists\n";
        cout << "line number=" << i+1 << ", d[]=" << d << endl;
        already_done=1;
        usage( "Already done, hence skip");
        break;
      }
    }
  }

  // .. get all the positions of the separator z
  cout << "..aim is to create " << sfull << endl;
  s=sfull;
  d=&s[0];
  l=strlen(d);
  int *p=new int[l+2];
  n=0;
  for(i=0; i<l; i++)
    if(d[i]==z){p[n]=i; n++;}
  cout << "number of folders involved=" << n << endl;

  // .. go backwards until a directory exists
  idir=0;
  for(i=n-1; i>=0; i--)
  {
    d[p[i]]=0;
    if(exists_dir(d))
    {
      cout << "directory=" << d << " exists" << endl;
      idir=i;
      break;
    }
  }

  // .. create folders from idir+1 onwards
  d[ p[idir] ]=z;
  for(i=idir+1; i<n; i++)
  {
    j=p[i];
    d[j]=0;
    cout << "..attempting to make " << d << ", j=" << j << endl;
    k=mkw_mkdir(d);
    if(exists_dir(d)==0 || k!=0)
    {
      cout << "..failed to make folder " << d << endl;
      usage("cannot continue");
    }
    cout << "..just created " << d << endl;
    d[j]=z;
  }

  // .. now copy argv[2] to sfull or append to the existing file
  int iapp=0;
  ofstream O;
  if(exists(&sfull[0])==0)
    copy_file(argv[2], sfull.c_str());
  else
  {
    cout << "..adding the lines to the end of the file\n\n";
    O.open(&sfull[0], ios::app);
    for(i=0; i<tm.nl; i++)
      O << tm.cl[i] << endl;
    O.close();
    iapp=1;
  }

  // .. check that it worked
  if(exists(&sfull[0])==0)
  {
    cout << sfull << " was not created" << endl;
    usage("..failed to create the file");
  }

  int n2, nf;
  char *c2=f2a(argv[2], n2);
  char *cf=f2a(&sfull[0], nf);

  if(n2!=nf && iapp==0)
  {
    cout << "number of bytes in " << argv[2] << " is " << n2 << endl;
    cout << "number of bytes in " << sfull << " is " << nf << endl;
    usage("..copy appears to have failed");
  }

  j=0;
  for(i=0; i<n2; i++)
    if(c2[i]!=cf[i])j++;
  if(j>0 && iapp==0)
  {
    cout << argv[2] << " and " << sfull << " have " << nf << " bytes"
         << " but " << j << " bytes are not the same" << endl;
    usage("..copy appears to have failed");
  }

  cout << sfull << " created which has " << nf << " bytes" << endl;
  if(j>0 && iapp==0)
    cout << "It has the same contents as " << argv[2] << endl;
 
  delete[] p;
  if(n2>0)delete[] c2; 
  if(nf>0)delete[] cf; 
  

  return 0;
}
