#include <stdio.h>
#include <time.h>
#include <string.h>
#include <sys/stat.h>

int main(int argc, char *argv[])
{
  // .. return 0 if argv[1] and argv[2] both exist and contain the same data
  // .. return 1 in all other cases

  struct stat finfo1, finfo2;
  FILE *fp1, *fp2;
  int ij1, ij2, i, v, n1, n2, nr1, nr2;
  const int N=16384;
  char c1[16384], c2[16384];

  // .. check if verbose mode
  v=0;
  for(i=3; i<argc; i++)
    if(argv[i][0]=='-' && argv[i][1]=='v')v=1;

  // .. verbose if not enough args
  if(argc<3)
  {
    v=1;
    if(v==1)printf("argc=%d, less than 2 files names given\n", argc);
    return 1;
  }


  // .. get the file details
  ij1=stat(argv[1], &finfo1);
  ij2=stat(argv[2], &finfo2);

  // .. deal with non-existent files
  if(ij1<0 || ij2<0)
  {
    v=1;
    if(ij1<0)printf("%s does not exist\n", argv[1]);
    if(ij2<0)printf("%s does not exist\n", argv[2]);
    return 1;
  }

  // ..check based on file size
  n1=finfo1.st_size;
  n2=finfo2.st_size;
  if(n1!=n2)
  {
    if(v==1)
      printf("files %s and %s differ as the sizes differ: %d  %d\n", 
             argv[1], argv[2], n1, n2);
    return 1;
  }

  // .. read in blocks until a difference is detected
  fp1=fopen(argv[1], "rb");
  fp2=fopen(argv[2], "rb");
  if(fp1==NULL)
    printf("..cannot open %s for reading\n", argv[1]);
  if(fp2==NULL)
    printf("..cannot open %s for reading\n", argv[2]);
  if(fp1==NULL || fp2==NULL)return 1;

  do
  {
    nr1=fread(c1, 1, N, fp1);
    nr2=fread(c2, 1, N, fp2);
    if(nr1!=nr2)
    {
      printf(
"both files have the same size but failed to read the same number oy bytes\n");
      return 1;
    }
    for(i=0; i<nr1; i++)
      if(c1[i]!=c2[i])
      {
        if(v==1)printf("same size but contents differ\n");
        return 1;
      }
    if(nr1<N || nr2<N)break;
  }while(1);

  if(v==1)printf("%s and %s have identical contents\n", argv[1], argv[2]);
  return 0;
}
