function smart_dir(dir_name)
%%     function smart_dir(dir_name)
%       This applies the smart indent feature of the matlab editor
%       to all .m files in the folder dir_name
%       The current directory is used if no name is given

if nargin<1
  dir_name=pwd;
end

% get list of m-files in the directory
files = dir( fullfile(dir_name, '*.m') );
files = {files.name};

n=numel(files);
if n==0
  return;
end

% save the current working directory
olddir=pwd;
cd(dir_name);
fulldir=pwd;

% loop thorough the files
for i=1:n
  % open file in editor, apply smart indentation, save and close
  f=fullfile(fulldir, files{i});
  fprintf('..about to apply smart indent to %s\n', f)

  doc = matlab.desktop.editor.openDocument( f );
  doc.smartIndentContents;
  doc.save;
  doc.close;
end

cd(olddir);
